local assets =
{		
	Asset("ANIM", "anim/mjolnir_builds.zip"),
	Asset("ANIM", "anim/swap_mjolnirs.zip"),
    Asset("ANIM", "anim/mjolnirs.zip"),
}

local prefabs =
{
    "globalmapicon",
	"redmjolnir_build",
	"bluemjolnir_build",
	"greenmjolnir_build",
	"purplemjolnir_build",
	"orangemjolnir_build",
	"yellowmjolnir_build",
	"nonemjolnir",
	"redmjolnir",
	"bluemjolnir",
	"greenmjolnir",
	"purplemjolnir",
	"orangemjolnir",
	"yellowmjolnir",
}

local colour ={
	"none",
	"red",
	"blue",
	"green",
	"purple",
	"orange",
	"yellow",
}

local function topocket(inst)
    if inst.icon ~= nil then
        inst.icon:Remove()
        inst.icon = nil
    end
end

local function toground(inst)
    if inst.icon == nil then
        inst.icon = SpawnPrefab("globalmapicon")
        inst.icon:TrackEntity(inst)
    end
end

local function init(inst)
    if not inst.components.inventoryitem:IsHeld() then
        toground(inst)
    end
end


--[[local function CallLightning(doer, target, pos)
	local caster = doer.components.inventoryitem.owner
    caster:StartThread(function()
        local pos = Vector3(pos:Get())
        TheWorld:PushEvent("ms_sendlightningstrike", pos)
    end)
	if caster ~= nil and caster.components.sanity ~= nil then
		caster.components.sanity:DoDelta(-5)
	end
	if caster then caster.components.talker:Say("电来！") end
	return true
end ]]

local function CallLightning(doer, target, pos)
	local boom = SpawnPrefab("lightning")
		boom:AddComponent("groundpounder")
		boom.components.groundpounder.destroyer = true
		boom.components.groundpounder.noTags = {"FX", "NOCLICK", "DECOR", "INLIMBO", "player", "structure", "heavy", "wall"}
		boom:AddComponent("combat")
		boom.components.combat.hitrange = 8
		boom.components.combat.attackrange = 8
		boom.components.combat.defaultdamage = 200
		boom.Transform:SetPosition(pos:Get())
		boom:DoTaskInTime(0.33, function() 
		--boom.Physics:SetActive(true) 
		boom.components.groundpounder:GroundPound()
		boom.components.groundpounder:GroundPound()
		end)
	local caster = doer.components.inventoryitem.owner
	if caster ~= nil and caster.components.sanity ~= nil then
		caster.components.sanity:DoDelta(-30)
		caster.components.hunger:DoDelta(-20)
	end
	if caster then caster.components.talker:Say("电来！") end
end
	----------
local function ItemTradeTest(inst, item)
    if item == nil then
        return false
    elseif string.sub(item.prefab, -3) ~= "gem" then
        return false, "NOTGEM"
    elseif string.sub(item.prefab, -11, -4) == "precious" then
        return false, "WRONGGEM"
    end
    return true
end
	----------
local function OnGemGiven(inst, giver, item)
    local mjolnir = SpawnPrefab(string.sub(item.prefab, 1, -4).."mjolnir")
    local container = inst.components.inventoryitem:GetContainer()
    if container ~= nil then
        local slot = inst.components.inventoryitem:GetSlotNum()
        inst:Remove()
        container:GiveItem(mjolnir, slot)
    else
        local x, y, z = inst.Transform:GetWorldPosition()
        inst:Remove()
        mjolnir.Transform:SetPosition(x, y, z)
    end
    mjolnir.SoundEmitter:PlaySound("dontstarve/common/telebase_gemplace")
end
	----------
local function buildmjolnir(colour)

	local function onattack(inst, attacker, target)
		--if target ~= nil and target:IsValid() and attacker ~= nil and attacker:IsValid() then
		--    SpawnPrefab("electrichitsparks"):AlignToTarget(target, attacker, true)
		--end
	-----------------------------------------------
		target:AddTag("tag")
		local aoepos = SpawnPrefab("electrichitsparks")
		if aoepos then
			local follower = aoepos.entity:AddFollower()
			follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0 )
		end

		if not target:IsValid() then		
			return
		end		
		-- 是否打醒
		--if target.components.sleeper and target.components.sleeper:IsAsleep() then
			--	target.components.sleeper:WakeUp()
		--end
	
		if target.sg ~= nil and not target.sg:HasStateTag("frozen") then
			target:PushEvent("attacked", { attacker = attacker, damage = 0 })
		end
		local pos = Vector3(target.Transform:GetWorldPosition())
		local events = TheSim:FindEntities(pos.x,pos.y,pos.z, 4)
		for k,v in pairs(events) do
			if v.components.health and not v:HasTag("tag") and not v:HasTag("player") and not v:HasTag("abigail") 
			and not v:HasTag("wall") and not v:HasTag("glommer") and not v:HasTag("companion") then
				local spark = SpawnPrefab("electrichitsparks")
				spark.Transform:SetPosition(v.Transform:GetWorldPosition())
				v.components.health:DoDelta(-50)
			end
		end
		target:RemoveTag("tag")
	-------------------------------------------------
	end
	
	local function onequip(inst, owner) 
		owner.AnimState:OverrideSymbol("swap_object", "swap_mjolnirs", "swap_"..colour.."mjolnir")
		owner.AnimState:Show("ARM_carry") 
		owner.AnimState:Hide("ARM_normal")
		local owner = nil
		if inst.components.inventoryitem ~= nil then 
			owner = inst.components.inventoryitem.owner
		end
		if inst._light == nil or not inst._light:IsValid() then
			inst._light = SpawnPrefab("minerhatlight")
		end
		if owner ~= nil then
			inst._light.entity:SetParent(owner.entity)
		end
	
	--
		if inst._vfx_fx_inst == nil or not inst._light:IsValid() then
			inst._vfx_fx_inst = SpawnPrefab("cane_victorian_fx")
			inst._vfx_fx_inst.entity:AddFollower()
		end
		if owner ~= nil then
			inst._vfx_fx_inst.entity:SetParent(owner.entity)
			inst._vfx_fx_inst.Follower:FollowSymbol(owner.GUID, "swap_object", 0, inst.vfx_fx_offset or 0, 0)	
		end
	--
		owner:AddTag("stronggrip")
		owner:RemoveTag("lightningtarget")
		if colour ~= "none" then
			inst.components.deployable:SetDeployMode(DEPLOYMODE.NONE)
		end
	end

	local function OnUnequip(inst, owner)
		owner.AnimState:Hide("ARM_carry")
		owner.AnimState:Show("ARM_normal")
		inst._light:Remove()
		inst._vfx_fx_inst:Remove()
		inst._vfx_fx_inst = nil
		owner:RemoveTag("stronggrip")
		owner:AddTag("lightningtarget")
		if colour ~= "none" then
			inst.components.deployable:SetDeployMode(DEPLOYMODE.PLANT)
		end		
	end
	
	local function ondeploy(inst, pt, deployer) 
		--print(inst.prefab)
		local build = SpawnPrefab(colour.."mjolnir_build")
		if build ~= nil then
			build.Transform:SetPosition(pt:Get())
			inst:Remove()
			build.components.pickable.canbepicked = true
			if deployer ~= nil and deployer.SoundEmitter ~= nil then
				deployer.SoundEmitter:PlaySound("dontstarve/common/plant")
			end
		end
	end
	
    local function fn()
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()
        inst.entity:AddSoundEmitter()
        inst.entity:AddMiniMapEntity()
        inst.entity:AddNetwork()

        inst.MiniMapEntity:SetIcon(colour.."mjolnir.tex")
		inst.MiniMapEntity:SetCanUseCache(false)
        inst.MiniMapEntity:SetDrawOverFogOfWar(true)

        MakeInventoryPhysics(inst)

        inst.AnimState:SetBank("mjolnirs")
        inst.AnimState:SetBuild("mjolnirs")
        inst.AnimState:PlayAnimation(colour.."mjolnir_idle")
        inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

        MakeInventoryFloatable(inst, "small", 0.05, {0.8, 0.75, 0.8})
		
		if colour == "green" then
			inst:AddTag("goggles")
		end
		inst:AddTag("sharp")
		inst:AddTag("gemsocket")
		inst:AddTag("trader")
		inst:AddTag("give_dolongaction")

        inst.entity:SetPristine()

        if not TheWorld.ismastersim then
            return inst
        end

        inst:AddComponent("tradable")
		
        inst:AddComponent("inspectable")

        inst:AddComponent("inventoryitem")
		inst.components.inventoryitem.atlasname = "images/inventoryimages/"..colour.."mjolnir.xml" -- 设置图片文档
		inst.components.inventoryitem.imagename = colour.."mjolnir"
	---------------------------------------------	
		inst:AddComponent("tool")
		inst.components.tool:SetAction(ACTIONS.CHOP, 5) 
		inst.components.tool:SetAction(ACTIONS.MINE, 5) 
	---------------------------------------------
		if colour == "blue" then
			inst:AddComponent("insulator")
			inst.components.insulator:SetSummer()
			inst.components.insulator:SetInsulation(240)
		end
		if colour == "red" then
			inst:AddComponent("insulator")
			inst.components.insulator:SetWinter()
			inst.components.insulator:SetInsulation(240)
		end
	---------------------------------------------
		inst:AddComponent("weapon")
		inst.components.weapon:SetDamage(51)
		inst.components.weapon:SetOnAttack(onattack)
		inst.components.weapon:SetElectric()	
	---------------------------------------------
		inst:AddComponent("spellcaster")
		inst.components.spellcaster:SetSpellFn(CallLightning)
		inst.components.spellcaster.canuseonpoint = true
		inst.components.spellcaster.canuseonpoint_water = true
		inst.components.spellcaster.quickcast = true 
	--------------------------------------------
		inst:AddComponent("equippable")
		inst.components.equippable:SetOnEquip(onequip)
		inst.components.equippable:SetOnUnequip(OnUnequip)
	---------------------------------------------
		if colour ~= "none" then
			inst:AddComponent("deployable")
			inst.components.deployable.ondeploy = ondeploy
			inst.components.deployable:SetDeployMode(DEPLOYMODE.PLANT)
			inst.components.deployable:SetDeploySpacing(5)
			inst.components.weapon:SetRange(2)
			inst.components.equippable.walkspeedmult = 1.25
		end
	---------------------------------------------
		if colour == "none" then
			inst:AddComponent("trader")
			inst.components.trader:SetAbleToAcceptTest(ItemTradeTest)
			inst.components.trader.onaccept = OnGemGiven
		end
		
        MakeHauntableLaunch(inst)

        inst.icon = nil
        inst:ListenForEvent("onputininventory", topocket)
        inst:ListenForEvent("ondropped", toground)
        inst:DoTaskInTime(0, init)

        inst.OnRemoveEntity = OnRemoveEntity
        return inst
    end

    return Prefab(colour.."mjolnir", fn, assets, prefabs)
end
	----------

local function laymjolnir(colour)
	
	local function onpickedfn(inst, picker)
		print(inst.prefab)
		if picker.components and picker.components.inventory then
			local potitem = SpawnPrefab("nonemjolnir")
			local gem = SpawnPrefab(colour.."gem")
			picker.components.inventory:GiveItem(potitem)
			picker.components.inventory:GiveItem(gem)
			inst:Remove()
			return true
		end
	end
	
	local function place_fn()
		local inst = CreateEntity()

		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		inst.entity:AddSoundEmitter()
		inst.entity:AddMiniMapEntity()
		inst.entity:AddLight()
		inst.entity:AddNetwork()
	
		inst.Light:Enable(true)
		inst.Light:SetRadius(18)
		inst.Light:SetFalloff(0.6)
		inst.Light:SetIntensity(0.7)
		if colour == "red" then
			inst.Light:SetColour(1, .1, .1)
		end
		if colour == "green" then
			inst.Light:SetColour(.1, 1, .1)
		end
		if colour == "blue" then
			inst.Light:SetColour(.5, .5, 1)
		end
		if colour == "purple" then
			inst.Light:SetColour(.5, .1, .5)
		end
		if colour == "orange" then
			inst.Light:SetColour(1, .4, .1)
		end
		if colour == "yellow" then
			inst.Light:SetColour(1, 1, .1)
		end
		MakeObstaclePhysics(inst, 0.34, 3)

		inst.AnimState:SetBank("mjolnir_builds")
		inst.AnimState:SetBuild("mjolnir_builds")
		inst.AnimState:PlayAnimation(colour.."mjolnir_build")
	
		inst:AddTag("structure")
	

		inst.entity:SetPristine()

		if not TheWorld.ismastersim then
			return inst
		end

		inst:AddComponent("inspectable")
	
		inst:AddComponent("lootdropper")
		
		inst:AddComponent("pickable")
		inst.components.pickable.picksound = "dontstarve/wilson/harvest_berries"
		inst.components.pickable.canbepicked = true
		inst.components.pickable.onpickedfn = onpickedfn

	
		MakeHauntableWork(inst)
	
		return inst
	end
	return Prefab(colour.."mjolnir_build", place_fn, assets, prefabs)
end


local function placermjolnir(colour)
	return 
		MakePlacer(colour.."mjolnir_placer", "mjolnir_build", "mjolnir_build", "idle")
end

return buildmjolnir("none"),
	buildmjolnir("purple"),
    buildmjolnir("blue"),
    buildmjolnir("red"),
    buildmjolnir("orange"),
    buildmjolnir("yellow"),
    buildmjolnir("green"),
	laymjolnir("purple"),
	laymjolnir("blue"),
	laymjolnir("red"),
	laymjolnir("orange"),
	laymjolnir("yellow"),
	laymjolnir("green"),
	placermjolnir("purple"),
	placermjolnir("blue"),
	placermjolnir("red"),
	placermjolnir("orange"),
	placermjolnir("yellow"),
	placermjolnir("green")
	